/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2004-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: serial.c 1801 2015-03-27 06:34:43Z t_ishikawa $
 */

/*
 *		ץꥢIO⥸塼
 */

#include	"Os.h"
#include	"target_serial.h"
#include	"target_sysmod.h"
#include	"serial.h"


/*
 *  ѥǡ
 */

static uint8	rx_char;
static boolean	rx_flag;

/*
 *  ꥢIO⥸塼
 *
 *  ߶ػ߾֤ǸƽФ
 */
void
InitSerial(void)
{
	/*
	 *  ե饰
	 */
	rx_flag = FALSE;

	/*
	 *  ¸¹
	 */
	InitHwSerial();
}

/*
 *  ꥢIO⥸塼߽
 *
 *  ϤλƤ뤳Ȥݾ㤷ʤʥǥåɥåɻߡ
 *  ƥȥåƽϤΤǡۤʤʺǸΣʸΤߡ
 *
 *  ߶ػ߾֤ǸƽФ
 */
void
TermSerial(void)
{
	/*
	 *  ¸¹
	 */
	TermHwSerial();

	/*
	 *  ǡ̵
	 */
	rx_flag = FALSE;
}

/*
 *  ʸ
 */
void
RecvPolSerialChar(uint8 *character)
{
	SuspendAllInterrupts();
	if (rx_flag != FALSE) {
		/*
		 *  ߶ػߤˤƼǡե饰ꥢ
		 */
		*character = rx_char;
		rx_flag = FALSE;
	}
	else {
		/*
		 *  ǡʤ'\0'֤
		 */
		*character = '\0';
	}
	ResumeAllInterrupts();
}

/*
 *  Хåؿ
 */
void
RxSerialInt(uint8 character)
{
	/*
	 *  ߶ػߤˤƼǡݻե饰ꥢ
	 */
	SuspendAllInterrupts();
	rx_char = character;
	rx_flag = TRUE;
	ResumeAllInterrupts();
}
